Fixes Made to Third Party Components
=================

polymer version: 1.2.4

---

webcomponentsjs
---------------
**webcomponent-lite.js**
   * GC-817: Dynamically appending cloudagent element to dom on Safari causes HTMLImport to fail. 
   
   		window.HTMLImports.addModule(function(scope) {
	   		...
	   		if (n === undefined || n === null) continue;
	    	if (!!n && n.toString().indexOf("<JSAPI-Auto Javascript Object>") != -1) continue;
	  		...
  		}


**webcomponents.js**  
  
   * GC-600: Polymer.updateStyles fails on safari  

            function wrap(impl) {
            // bc: Fix to avoid exception on Safari when calling Polymer.updateStyles() [...
            //if (impl === null) return null;
            if ((impl === null) || (impl === undefined)) return null;
            //...]
            
   * GC-337: Creating an app using Application template seems to have flow layout (FF only)
   
         removeChild: function(childWrapper) {
    // fix to avoid exception on FireFox during drag and drop from the palette.
	//        assertIsNodeWrapper(childWrapper);  
   

**webcomponents-min.js**

   *  above fixes, minified:
       jsmin < webcomponents.js > webcomponents-min.js

NOTE: not filed as an issue on github yet.

---

polymer
--------

**polymer-mini.html**

* GC-600: Polymer.updateStyles fails on safari 
  * When using webcomponents-lite.js, the problem occurs in polymer-mini.html

            _queryElements: function (elements, matcher, halter, list) {
                // bc: Prevent exception on Safari when using webcomponents-lite.js and calling Polymer.updateStyles()  [...
                if (!elements) return;
                // ...]

**polymer.html**

* Log an error instead of crashing if async is called without a callback function specified

        async: function (callback, waitTime) {
          var self = this;
          // bc : [...
          if ((callback) && (callback.call)) {
              // ...]

              return Polymer.Async.run(function () {
                  callback.call(self);
              }, waitTime);
              // [...
           } else {
              console.error("Error: Polymer.async called without a callback defined! returning immediately.");
              return;
          }
          // ...]
         },
         
* Add console log statements to help track down improperly formed properties instead of crashing

            _propertySetter: function (property, value, effects,   fromAbove) {
                 // bc: [...
                if (!this.__data__){
                    console.error("polymer._propertySetter: trying to set property "+property+" on undefined.");
                    return null;
                }
                // ...]
                
* Add console log statements to help track down problems calling observer functions instead of crashing

          _applyEffectValue: function (info, value) {
               var node = this._nodes[info.index];
               // bc [...
              if (!node){
                          console.error("Polymer._applyEffectValue: ERROR - this._nodes[info.index] is not defined.  info="+info);
                          return;
              }
              // ...]
              var property = info.name;
              if (info.isCompound) {
                  // bc: [...
                  if ((!property) || (!node.__compoundStorage__)){
                      console.error("Polymer._applyEffectValue: ERROR - node.__compoundStorage__ is not defined.  info="+info+", property="+property);
                      return;
                  }
                  // ...]
                  var storage = node.__compoundStorage__[property];
                  storage[info.compoundIndex] = value;
                  value = storage.join('');
              }
 
              
* gracefully handle case where property attribute key/value pair is not properly defined.  Log error info to make it easier to debug.

            _parseKey: function (key) {
               // bc: [...
               if ((key === undefined) || (key === "undefined")) {
                   console.error("Polymer._parseKey: ERROR! attempting to parse an undefined key!");
                   return;
               }
               // ...]
               if (key && key[0] == '#') {
                   return key.slice(1);
               }
           },

---
 
 hydrolysis
--------------------------

**hydrolysis.js**

* removed the source mapping '#' symbol at the bottom of the file to workaround nw issue.
https://github.com/nwjs/nw.js/issues/2738 

---
           
           
paper-ripple
------------
**paper-ripple.html**

Often getting exception because parentNode is undefined, so test it before using it.  (in the *attached* method)

paper-menu
--------------

**paper-submenu.html**

 fix typo:  change dettached: to detached:  
             
---

marked
---------

**marked/lib/marked.js**

NOTE: this file (including modifications) has been copied into mark-down/lib in order for it to be included in the components that are exported when exporting a project or a standalone app.

  * Rework handling of images and links so that they can be relative to the app folder within a project.

        Renderer.prototype.link = function(href, title, text) {
          if (this.options.sanitize) {
            try {
              var prot = decodeURIComponent(unescape(href))
                .replace(/[^\w:]/g, '')
                .toLowerCase();
            } catch (e) {
              return '';
            }
            if (prot.indexOf('javascript:') === 0 || prot.indexOf('vbscript:') === 0) {
              return '';
            }
          }
            //Brian Cruickshank: handle things differently in node-webkit, otherwise we end up
            // opening a frameless window with no toolbar and no way to close or navigate.
            var out;
            if (typeof process !== "undefined"){
                out = '<a ';
                if (title) {
                    out += ' title="' + title + '"';
                }
                out += ' onclick="require(\'nw.gui\').Shell.openExternal(\''+ href +'\')">' + text + '</a>';
            } else {
                out = '<a href="' + href + '"';
          if (title) {
            out += ' title="' + title + '"';
          }
                //Brian Cruickshank: always open links in a new window to prevent corrupting design
                //out += '>' + text + '</a>';
                out += ' target="_blank">' + text + '</a>';
            }
          return out;
        };

        var   inDesigner = function(){
                var result = false;
                if ((window.parent)&&(window.parent.document) && (window.parent.document.querySelector('#designer'))){
                    result = true;
                }
                return result;
        };
        Renderer.prototype.image = function(href, title, text) {
          var out = '<img src="' + href + '" alt="' + text + '"';
          // TODO: Polymer 1.2 - in projectUpdateWizard, change ![abc](app/xyx) to ![abc](xyz)
            if (href.length > 0){
              if (inDesigner()) {
                gc = gc || {};
                // base URL is <ti-guicomposer-designer folder>/designer/components/element, so need to go down 3 levels and up to project app folder
                out = '<img src="' + gc.designer.project.folderName + '/app/' + href + '" alt="' + text + '"';
              } else {
                out = '<img src="app/' + href + '" alt="' + text + '"';
              }
            }

          if (title) {
            out += ' title="' + title + '"';
          }
          out += this.options.xhtml ? '/>' : '>';
          return out;
        };
  
  
---

iron-icon
----------

**iron-icon.html**

  * Move style section inside of template to avoid warning message on Firefox
  * add is="custom-style" attribute to style tag
  
  bug fix for changing icon src to use an image, then changing back to an icon
  and the image is still present and covering the icon.
  
  _updateIcon method
   
          if (this._img) {  
            this._img.style.display = 'none';
          }
        } else {
          if (!this._img) {
            this._img = document.createElement('img');
            this._img.style.width = '100%';
            this._img.style.height = '100%';
            this._img.draggable = false;
          } else {
              this._img.style.display = '';
          }
    
 ---
 
 iron-overlay-behavior
--------------------------

**iron-overlay-backdrop.html**

  *  Move style section inside of template to avoid warning message on Firefox
  * add is="custom-style" attribute to style tag
  
  
 iron-behaviors
---------------

**iron-button-state.html**

  *  Added "notify: true" to pressed property definition, so that we can bind to the pressed state of buttons. 
  
 iron-menu-behavior 
-------------------

**iron-menu-behavior.html**

 * in _onEscKey event handler, add check to verify focusedItem is defined before calling blur function on it
 
        _onEscKey: function(event) {
               // esc blurs the control
                 //bc: only call blur function if focusedItem is defined
                 if (focusedItem) {
                     this.focusedItem.blur();
                 }
        },
 
paper-ripple
-------------

        /* bc: Often getting exception because parentNode is undefined, so test it before using it [...
        if (this.parentNode.nodeType == 11) { // DOCUMENT_FRAGMENT_NODE
          target = ownerRoot.host;
        ..] [... */
        if ((!this.parentNode) || (this.parentNode.nodeType == 11)) { // DOCUMENT_FRAGMENT_NODE
          if (ownerRoot) {
            target = ownerRoot.host;
          }
          // ...]  

iron-jsonp-library.html
-----------------------
    cleanup: function() {
        //bc: see https://github.com/MetaMask/metamask-extension/issues/447
        // the following results in e.g. Uncaught TypeError: Cannot delete property 'onYouTubeIframeAPIReady' of #<Window>
        //delete window[this.callbackName];
        window[this.callbackName] = undefined;
    },

paper-range-slider
-------------------

**paper-range-slider.html**

 * Bind pin property in template
 
        <!-- TI_CHANGE bind pin property -->
        <paper-single-range-slider id='sliderMax' disabled$="[[disabled]]" on-down="_sliderMaxDown"
                      on-up="_sliderMaxUp" step="[[step]]" min="[[min]]" max="[[max]]"
                      value="[[valueMax]]" secondary-progress='[[max]]' pin="[[pin]]" style="width:100%;">
        </paper-single-range-slider>

        <div class="divSpanWidth" style="pointer-events: none;">
          <paper-single-range-slider id='sliderMin' disabled$="[[disabled]]" on-down="_sliderMinDown"
                        on-up="_sliderMinUp" noink step="[[step]]" min="[[min]]" max="[[max]]"
                        value="[[valueMin]]" pin="[[pin]]" style="width:100%;">
          </paper-single-range-slider>
        </div>

  * Call clampValue to make sure value is multiple of increment

        // TI_CHANGE use clampValue to round value to nearest increment step
        return [this._clampValue(valueNowMin), this._clampValue(valueNowMax)];

  * Fire change event in backDivTrackEnd to notify value changed when dragging middle bar

        _backDivTrackEnd: function() {
          // TI_CHANGE notify change when dragging middle bar
          this.fire('change');
        },