/**
 * @copyright 2015, Texas Instruments
 * @owner bbelyavsky
 * 
 * /api/ccscloud.js
 */


(function() {
	if (!!window.CCSCloudIDE) return;
	
	
	var CCSCLOUD_WINDOW_NAME = 'ccscloud';
	
	var m_ccscloudWindow = null;
	var m_serverUrl = null;
	var m_form = null;
	var m_input = null;

	var m_self = window.CCSCloudIDE;
	if(!m_self) {
		m_self = window.CCSCloudIDE = {};

		m_serverUrl = '';
		
		m_form = window.document.createElement('form');
		m_form.appendChild(m_input = window.document.createElement('input'));
		m_form.style.display = 'none';
		
		window.document.body.appendChild(m_form);
	}
	
	/**
	 * TODO [bbelyavsky]: 
	 */
	m_self.setServerUrl = function(url) {
		m_serverUrl = url;
	};
	
	/**
	 * TODO [bbelyavsky]: 
	 */
	m_self.createProject = function(projectName, deviceId, files) {
		this.ensureWindowOpen();
		
		m_form.action = m_serverUrl + '/ide/api/ccsserver/createProject?projectName=' + projectName + '&deviceId=' + deviceId;
		m_form.target = CCSCLOUD_WINDOW_NAME;
		m_form.method = 'post';

		m_input.name = 'json';
		m_input.value = JSON.stringify({ files:files });
		
		m_form.submit();
	};
	
	/**
	 * TODO [bbelyavsky]: 
	 */
	m_self.createProjectFromSpec = function(projectSpec, projectName, deviceId, files) {
		this.ensureWindowOpen();
		
		m_form.action = m_serverUrl + '/ide/api/ccsserver/createProject?projectSpec=' + projectSpec + '&projectName=' + projectName + '&deviceId=' + deviceId;
		m_form.target = CCSCLOUD_WINDOW_NAME;
		m_form.method = 'post';

		m_input.name = 'json';
		m_input.value = JSON.stringify({ files:files });
		
		m_form.submit();
	};
	
	/**
	 * TODO [bbelyavsky]: 
	 */
	m_self.createSketch = function(projectName, boardId, enableMultiTasking, files) {
		this.ensureWindowOpen();
		
		m_form.action = m_serverUrl + '/ide/api/ccsserver/createSketch?projectName=' + projectName + '&boardId=' + boardId + '&enableMultiTasking=' + enableMultiTasking;
		m_form.target = CCSCLOUD_WINDOW_NAME;
		m_form.method = 'post';

		m_input.name = 'json';
		m_input.value = JSON.stringify({ files:files });
		
		m_form.submit();
	};
	
	/**
	 * TODO [bbelyavsky]: 
	 */
	m_self.uploadFiles = function(targetDirectory, files) {
		this.ensureWindowOpen();
		
		m_form.action = m_serverUrl + '/ide/api/ccsserver/uploadFiles?targetDirectory=' + targetDirectory;
		m_form.target = CCSCLOUD_WINDOW_NAME;
		m_form.method = 'post';

		m_input.name = 'json';
		m_input.value = JSON.stringify({ files:files });
		
		m_form.submit();
	};
	
	/**
	 * TODO [bbelyavsky]: 
	 */
	m_self.ensureWindowOpen = function() {
		if(!m_ccscloudWindow || m_ccscloudWindow.closed) {
			m_ccscloudWindow = window.open('', CCSCLOUD_WINDOW_NAME);
		}
		else {
			m_ccscloudWindow.focus();
		}
	};
	
})();
